var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import React from 'react';
import { StaticQuery, graphql, Link } from 'gatsby';
import styled from 'styled-components';
var QUERY = graphql(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  query Sidebar {\n    allSitePage {\n      edges {\n        node {\n          id\n          path\n          context {\n            frontmatter {\n              title\n              menu\n              order\n            }\n          }\n        }\n      }\n    }\n\n    site {\n      siteMetadata {\n        menu\n      }\n    }\n  }\n"], ["\n  query Sidebar {\n    allSitePage {\n      edges {\n        node {\n          id\n          path\n          context {\n            frontmatter {\n              title\n              menu\n              order\n            }\n          }\n        }\n      }\n    }\n\n    site {\n      siteMetadata {\n        menu\n      }\n    }\n  }\n"])));
var createOrFindGroup = function (name, groups) {
    var group = groups.find(function (group) { return group.name === name; });
    if (!group) {
        group = { name: name, pages: [] };
        groups.push(group);
    }
    return group;
};
var sortByOrder = function (a, b) {
    var diff = (a.context.frontmatter.order || 0) - (b.context.frontmatter.order || 0);
    return diff === 0 ? 0 : diff > 0 ? 1 : -1;
};
var pagesToNavGroups = function (pages) { return pages.reduce(function (groups, page) {
    if (!page.context.frontmatter.menu) {
        return groups;
    }
    var group = createOrFindGroup(page.context.frontmatter.menu, groups);
    group.pages.push(page);
    group.pages.sort(sortByOrder);
    return groups;
}, []); };
var ListGroup = styled.ul(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  margin: 0;\n  padding: 0;\n\n  ul {\n    padding: 0 0 0 10px;\n  }\n"], ["\n  margin: 0;\n  padding: 0;\n\n  ul {\n    padding: 0 0 0 10px;\n  }\n"])));
var Nav = styled.nav(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  padding: 0 20;\n"], ["\n  padding: 0 20;\n"])));
var NavGroup = styled(ListGroup)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  margin-bottom: 20;\n"], ["\n  margin-bottom: 20;\n"])));
var NavItemBasic = styled.div(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  padding: 12px 20px;\n"], ["\n  padding: 12px 20px;\n"])));
var NavGroupTitle = styled(NavItemBasic)(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n  font-size: 17;\n  font-weight: 500;\n"], ["\n  font-size: 17;\n  font-weight: 500;\n"])));
var NavGroupMenu = styled(ListGroup)(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n"], ["\n"])));
var NavGroupMenuItem = styled.li(templateObject_8 || (templateObject_8 = __makeTemplateObject(["\n  padding: 8px 20px;\n  list-style-type: none;\n\n  a {\n    color: nav-link;\n    display: block;\n    transition: base;\n    transition-property: color;\n    padding-left: 10;\n    border-left: 3;\n    border-color: transparent;\n\n    &:hover {\n      color: nav-link-hover;\n    }\n\n    &.active {\n      font-weight: 600;\n      border-left: 3;\n      border-color: primary;\n    }\n  }\n"], ["\n  padding: 8px 20px;\n  list-style-type: none;\n\n  a {\n    color: nav-link;\n    display: block;\n    transition: base;\n    transition-property: color;\n    padding-left: 10;\n    border-left: 3;\n    border-color: transparent;\n\n    &:hover {\n      color: nav-link-hover;\n    }\n\n    &.active {\n      font-weight: 600;\n      border-left: 3;\n      border-color: primary;\n    }\n  }\n"])));
var sortGroupsWithConfig = function (sideMenuFromConfig) { return function (a, b) {
    var indexA = sideMenuFromConfig.indexOf(a.name);
    var indexB = sideMenuFromConfig.indexOf(b.name);
    var diff = indexA - indexB;
    // eslint-disable-next-line no-nested-ternary
    return diff === 0 ? 0 : (diff < 0 ? -1 : 1);
}; };
export function SideNav() {
    return (React.createElement(StaticQuery, { query: QUERY, render: function (data) {
            var navGroups = pagesToNavGroups(data.allSitePage.edges
                .map(function (edge) { return edge.node; })
                .filter(function (node) { return node.context && node.context.frontmatter; }));
            navGroups.sort(sortGroupsWithConfig(data.site.siteMetadata.menu));
            return (React.createElement(Nav, null, navGroups.map(function (navGroup) { return (React.createElement(NavGroup, { key: navGroup.name },
                React.createElement(NavGroupTitle, null, navGroup.name),
                React.createElement(NavGroupMenu, null, navGroup.pages.map(function (page) { return (React.createElement(NavGroupMenuItem, { key: page.id },
                    React.createElement(Link, { activeClassName: "active", to: page.path }, page.context.frontmatter.title))); })))); })));
        } }));
}
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8;
